﻿init python:
    import random
    # import time
    # random.seed(time.clock())
    def chance(percent):
        c = random.randint(0, 100)
        if c < percent:
            return True
        else:
            return False
    renpy.music.register_channel("sfx1", "sfx", True)
    renpy.music.register_channel("sfx2", "sfx", True)
    renpy.music.register_channel("sfx3", "sfx", True)
    class bubble_rush_class:
        def __init__(self, rows, cols, stars, pops):
            self.rows = rows
            self.cols = cols
            self.all_stars = stars
            self.pops = pops
            self.colors = 3
            self.stars = self.all_stars[:self.colors]

            self.current = random.choice(self.stars)
            self.speed = 0
            self.passed = 0
            self.lives = 3

            self.points = 0
            self.damage = [None]*self.rows

            self.state = "start"
            self.density = 50
            self.ninja = self.rows // 2

            self.board = []
            self.bullets = []
            self.init()
            for i in range(4):
                self.spawn()
        def level_up(self):
            if self.colors < len(self.all_stars):
                self.colors += 1
                self.stars = self.all_stars[:self.colors]
                self.speed = 0
                self.lives += 1
                renpy.play("bubbles/level_up.ogg", "sound")
        def init(self):
            b = []
            for i in range(self.cols):
                row = []
                for i in range(self.rows):
                    row.append(None)
                b.append(row)
            self.board = b
        def start(self):
            self.colors = 3
            self.stars = self.all_stars[:self.colors]
            self.current = random.choice(self.stars)
            self.speed = 0
            self.passed = 0
            self.lives = 3
            self.points = 0
            self.damage = [None]*self.rows
            self.density = 50
            self.ninja = self.rows // 2
            self.bullets = []
            self.init()
            for i in range(4):
                self.spawn()
            self.state = "playing"

        def move(self, direction):
            self.ninja += direction
            if self.ninja < 0:
                self.ninja = 0
            elif self.ninja > self.rows-1:
                self.ninja = self.rows-1

        def spawn(self):
            for i in self.damage:
                if not i:
                    break
            else:
                self.damage = [None]*self.rows
                for n,i in enumerate(self.board):
                    for m,j in enumerate(i):
                        if j:
                            self.board[n][m] = "bubble_burst"
                self.lives -= 1
                renpy.play("bubbles/explosion.ogg", "sfx2")
                if self.lives < 1:
                    self.state = "lost"
                    renpy.play("bubbles/death.ogg", "sfx3")
                return
            row = []
            for i in range(self.rows):
                if chance(self.density):
                    b = random.choice(self.stars)
                else:
                    b = None
                row.append(b)
            p = self.board.pop(-1)
            self.board.insert(0, row)
            for n,i in enumerate(p):
                if i:
                    if not self.damage[n]:
                        self.damage[n] = i
                        p[n] = None
                    else:
                        for m,j in enumerate(self.damage):
                            if not j:
                                self.damage[m] = i
                                break

                
        def shoot(self):
            if self.state == "playing":
                self.bullets.append([self.ninja, self.cols, self.current, True])
                self.current = random.choice(self.stars)
                # renpy.play("bubbles/shoot.ogg", "sound")
        def discard(self):
            if self.state == "playing":
                star = random.choice(self.stars)
                while star == self.current:
                    star = random.choice(self.stars)
                self.current = star
                # renpy.play("bubbles/discard.ogg", "sound")
        def tick(self):
            for y,i in enumerate(self.board):
                for x,j in enumerate(i):
                    if j == "bubble_burst":
                        self.board[y][x] = None
                        self.points += 1
                        if not self.points % 10:
                            self.speed += 1

            for i,j in enumerate(self.bullets):
                miss = True
                self.bullets[i][1] -= 1
                if self.bullets[i][1] < 0:
                    if self.bullets[i][3]:
                        self.spawn()
                        self.passed = 0
                        renpy.play("bubbles/fail.ogg", "sound")
                    self.bullets.remove(j)
                if self.board[j[1]][j[0]] == j[2]:
                    self.board[j[1]][j[0]] = None
                    try:
                        self.bullets[i][3] = False
                    except:
                        pass
                    self.board[j[1]][j[0]] = "bubble_burst"
                    renpy.play(random.choice(self.pops), "sfx1")
            self.passed += 1
            if self.passed > 100-self.speed:
                self.passed = 0
                self.spawn()


image bubble_red = Crop((0,0,32,32), "bubbles")
image bubble_green = Crop((32,0,32,32), "bubbles")
image bubble_blue = Crop((64,0,32,32), "bubbles")
image bubble_purple = Crop((96,0,32,32), "bubbles")

image bubble_orange = Crop((0,32,32,32), "bubbles")
image bubble_yellow = Crop((32,32,32,32), "bubbles")
image bubble_black = Crop((64,32,32,32), "bubbles")
image bubble_white = Crop((96,32,32,32), "bubbles")

image bubble_bubble = Crop((0,64,32,32), "bubbles")
image bubble_burst = Crop((32,64,32,32), "bubbles")
image bubble_empty = Crop((64,64,32,32), "bubbles")

image bubble_frame = Crop((0,96,32,32), "bubbles")


default bubble_rush_ins = bubble_rush_class(
    5, 7,
    [
        "bubble_red",
        "bubble_green",
        "bubble_blue",
        "bubble_purple",
        "bubble_orange",
        "bubble_yellow",
        "bubble_black",
        "bubble_white",
    ],
    [
        "bubbles/bubble_1.ogg",
        "bubbles/bubble_2.ogg",
        "bubbles/bubble_3.ogg",
        "bubbles/bubble_4.ogg",
        "bubbles/bubble_5.ogg",
        "bubbles/bubble_6.ogg",
        "bubbles/bubble_7.ogg",
    ]
    )


screen bubble_rush(g = bubble_rush_ins):
    modal True
    if g.state == "playing":
        key "a" action Function(g.move, -1)
        key "d" action Function(g.move, 1)
        key "w" action Function(g.shoot)
        key "s" action Function(g.discard)
        timer .04 repeat True action Function(g.tick)
    else:
        key "a" action NullAction()
        key "d" action NullAction()
        key "w" action NullAction()
        key "s" action NullAction()

    frame align .5,.5 background Frame("bubble_frame", 4, 4):
        at zoom(3)
        fixed fit_first True:
            vbox:
                bar value g.passed range 100-g.speed xysize g.rows*32,1 left_bar "#fff" right_bar "#444" yoffset -10
                for y in g.board:
                    hbox:
                        for x in y:
                            if x:
                                if x == "bubble_burst":
                                    add "bubble_burst"
                                else:
                                    fixed fit_first True:
                                        add x
                                        add "bubble_bubble"
                            else:
                                add "bubble_empty"
                hbox:
                    for x in g.damage:
                        fixed xysize 32,32:
                            at alpha(.2)
                            if x:
                                add x
                                add "bubble_bubble"
                fixed xysize 32,1 yoffset -16:
                    xoffset g.ninja*32 
                    add g.current
            for i in g.bullets:
                add i[2] offset i[0]*32,i[1]*32
    frame align .0,.5 xoffset 20 background Frame("bubble_frame", 4, 4) padding 8,8:
        vbox spacing 4:
            hbox:
                text "Colors: "
                for i in g.stars:
                    add i at zoom(1.5)
            text f"Points: {g.points}"
            text f"speed: {g.speed}"
            text f"Lives: {g.lives}"
            if g.state == "playing":
                button background Frame("bubble_frame", 4, 4) padding 8,8:
                    text "Level up!"
                    action Function(g.level_up) keysym "K_SPACE"
            elif g.state == "lost":
                button background Frame("bubble_frame", 4, 4) padding 8,8:
                    text "Retry"
                    action Function(g.start)
                button background Frame("bubble_frame", 4, 4) padding 8,8:
                    text "Exit"
                    action Return(g.points)
            elif g.state == "start":
                button background Frame("bubble_frame", 4, 4) padding 8,8:
                    text "Start"
                    action Function(g.start) keysym "K_SPACE"



transform alpha(a):
    alpha a
transform zoom(z):
    nearest True
    zoom z
label bubble_rush_example:
    call screen bubble_rush
